# goby project

The Goby Underwater Autonomy Project aims to create a unified framework for multiple scientific autonomous marine vehicle collaboration, seamlessly incorporating acoustic, ethernet, wifi, and serial communications. Goby provides a publish/subscribe middleware that operates on the concept of unified Nested Communications, with differing layers for interthread, interprocess, and intervehicle communications.

For Release 2.1.1 and newer, Goby uses the standalone DCCL project: https://github.com/GobySoft/dccl

- Contact Toby (https://github.com/tsaubergine) for information on becoming involved with goby.
- Documentation: http://gobysoft.org/doc/3.0/)
- Wiki: https://github.com/GobySoft/goby3/wiki (also see older wiki: https://github.com/GobySoft/goby/wiki)
- Mailing list: goby@mit.edu; join: http://mailman.mit.edu/mailman/listinfo/goby.
- Release Ubuntu packages: https://launchpad.net/~goby-dev/+archive/ppa)
- Nightly testing Ubuntu packages: https://code.launchpad.net/~tes/+archive/goby-daily)

## goby3 middleware

Documentation is still a work in progress. As components get finalized, the goby3-examples repository (https://github.com/GobySoft/goby3-examples) is the best place to see working examples. You may fork this project as a starting point for your own projects using Goby3 so you don't need to configure your own build environment from hand.

## compiling goby

please read the INSTALL.txt file in this directory

## goby licensing

please read the COPYING file found in this directory

## contributing to Goby

please read the AUTHORS file found in this directory for instructions on how to contribute to Goby. You can fork the project and use the Github pull request system for submitting bug fixes and new features.

## reporting bugs and other issues

please use the Github issue tracking system to report bugs or inconsistencies in the software or documentation. If you have a fix, this is greatly appreciated as well.

