// Copyright 2011-2021:
//   GobySoft, LLC (2013-)
//   Massachusetts Institute of Technology (2007-2014)
//   Community contributors (see AUTHORS file)
// File authors:
//   Toby Schneider <toby@gobysoft.org>
//
//
// This file is part of the Goby Underwater Autonomy Project Binaries
// ("The Goby Binaries").
//
// The Goby Binaries are free software: you can redistribute them and/or modify
// them under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// The Goby Binaries are distributed in the hope that they will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Goby.  If not, see <http://www.gnu.org/licenses/>.

#include <dccl/dynamic_protobuf_manager.h> // for Dynami...

#include "goby/middleware/application/configuration_reader.h" // for Config...
#include "goby/moos/goby_moos_app.h"                          // for run
#include "goby/moos/transitional/message_algorithms.h"        // for DCCLAl...

#include "pTranslator.h" // for CpTran...

int main(int argc, char* argv[])
{
    int return_value = goby::moos::run<goby::apps::moos::CpTranslator>(argc, argv);

    goby::moos::transitional::DCCLAlgorithmPerformer::deleteInstance();
    goby::apps::moos::CpTranslator::delete_instance();
    dccl::DynamicProtobufManager::protobuf_shutdown();

    return return_value;
}
